#!/bin/sh
set -e
set -x

if [ "$#" -lt 1 ]; then
  echo "Need public key ID and optionally old server IP."
  false
fi
gpg_key="$1"
old_server="$2"

config_tree_prefix="${HOME}/config/buster"
./install_for_target.sh play
./copy_dirtree.sh "${config_tree_prefix}/etc_files" "" play
cp "${config_tree_prefix}/other_files/weechatrc" /home/plom/.weechatrc
cp "${config_tree_prefix}/other_files/weechat-wrapper.sh" /home/plom/
cp "${config_tree_prefix}/other_files/weechatlogs_encrypter.sh" /home/plom/
chown plom:plom /home/plom/*weechat*
chown plom:plom /home/plom/.weechatrc
echo "${gpg_key}" > /home/plom/.encrypt_target
chown plom:plom /home/plom/.encrypt_target

# TODO refactor with setup_website.sh
# Add encryption key.
keyservers='sks-keyservers.net/ keys.gnupg.net'
set +e
while true; do
    do_break=0
    for keyserver in $(echo "${keyservers}"); do
        su plom -c "gpg --no-tty --keyserver $keyserver --recv-key ${gpg_key}"
        if [ $? -eq "0" ]; then
            do_break=1
            break
        fi
        echo "Attempt with keyserver ${keyserver} unsuccessful, trying other."
    done
    if [ "${do_break}" -eq "1" ]; then
        break
    fi
done
set -e

if [ "${old_server}" != "" ]; then
  cp "${config_tree_prefix}/setup_scripts/prepare_to_meet_server.sh" /home/plom/
  su -lc "./prepare_to_meet_server.sh ${old_server}" plom
  read -p'Hit Enter when you are done.' ignore
  rm /home/plom/prepare_to_meet_server.sh
  su -lc "scp plom@${old_server}:.ssh/authorized_keys .ssh/authorized_keys" plom
  su -lc "scp plom@${old_server}:.weechatrc ~" plom
  cp "${config_tree_prefix}/setup_scripts/mirror_dir.sh" /home/plom/
  su -lc "./mirror_dir.sh ${old_server} /home/plom/weechatlogs" plom
  rm /home/plom/mirror_dir.sh
fi

systemctl enable --now encrypt_chatlogs.timer
